unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBCtrls, ExtCtrls, Grids, DBGrids, DB, DBClient, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ClientDataSet1: TClientDataSet;
    ClientDataSet2: TClientDataSet;
    ClientDataSet3: TClientDataSet;
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    DataSource3: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    DBLookupComboBox1: TDBLookupComboBox;
    DBLookupComboBox2: TDBLookupComboBox;
    ClientDataSet1md001: TStringField;
    ClientDataSet1mx001: TStringField;
    ClientDataSet2md001: TStringField;
    ClientDataSet3md001: TStringField;
    ClientDataSet3mx001: TStringField;
    ComboBox1: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure DBLookupComboBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  i,j : Integer;
begin
  Randomize();
  ClientDataSet1.Close;
  ClientDataSet1.CreateDataSet;
  ClientDataSet2.Close;
  ClientDataSet2.CreateDataSet;
  ClientDataSet3.Close;
  ClientDataSet3.CreateDataSet;
  for i := 1 to 10 do
    begin
      ClientDataSet2.Append;
      ClientDataSet2.FieldByName('md001').AsString := FormatFloat('00000',I);
      ClientDataSet2.Post;
      for j := 1 to Random(5) do
        begin
          ClientDataSet3.Append;
          ClientDataSet3.FieldByName('md001').AsString := FormatFloat('00000',I);
          ClientDataSet3.FieldByName('mx001').AsString := FormatFloat('00000',I) + '-MB' + FormatFloat('00000000000',J);
          ClientDataSet3.Post;
        end;
    end;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  if FindComponent(TComboBox(Sender).Text) <> NIL then
    DBGrid1.DataSource := TDataSource(FindComponent(TComboBox(Sender).Text));
end;

procedure TForm1.DBLookupComboBox1Click(Sender: TObject);
begin
  ClientDataSet3.Filtered := False;
  ClientDataSet3.Filter := 'md001 = ' + Quotedstr(TDBLookupComboBox(Sender).Text);
  ClientDataSet3.Filtered := True;
  DBLookupComboBox2.KeyValue := '';
end;

end.
